package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    T[] list;

    public ArrayUtility(T[] list) {
        this.list = list;
    }

    public int getNumberOfOccurrences(T element) {
        int count = 0;
        for (T el : list){
            if (el.equals(element)){
                count++;
            }
        }
        return count;
    }

    public Object[] merge(T[] arr){
        int counter = 0;
        Object[] mergearr = new Object[list.length + arr.length];
        for (T el : list ){
            mergearr[counter] = el;
            counter++;
        }
        for (T el: arr){
            mergearr[counter] = el;
            counter++;
        }
        return mergearr;
    }

    public int countDuplicatesInMerge(T[] arrayUtility, T valueToEvaluate) {
        ArrayUtility arrayUtil = new ArrayUtility(merge(arrayUtility));
        return arrayUtil.getNumberOfOccurrences(valueToEvaluate);
    }


    public T getMostCommonFromMerge(T[] arrayToMerge) {
        ArrayUtility newArr = new ArrayUtility(merge(arrayToMerge));
        int count = 0;
        T mostCommon = null;
        for (Object el : newArr.list){
            if (getNumberOfOccurrences((T)el) > count){
                count = getNumberOfOccurrences((T)el);
                mostCommon=(T)el;
            }
        }
        return mostCommon;
    }

    public T[] removeValue(T valueToRemove) {
    ArrayList<T> newArr = new ArrayList<>();//[list.length - getNumberOfOccurrences(valueToRemove)];
        for (int i = 0; i < list.length; i++) {
            if (!list[i].equals(valueToRemove)){
                newArr.add(list[i]);
            }
        }
        int newLength = newArr.size();
        list = (T[]) Array.newInstance(list.getClass().getComponentType(), newLength);

        return newArr.toArray(list);
    }
}
